Attribute VB_Name = "Module1"
Option Explicit


Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Const GWL_EXSTYLE As Long = -20
Private Const WS_EX_APPWINDOW As Long = &H40000

Dim Arr() As String

Public Function fEnumWindows() As Variant
    ReDim Arr(0)
    Call EnumWindows(AddressOf fEnumWindowsCallBack, GetDesktopWindow)
    fEnumWindows = Arr
End Function

Private Function fEnumWindowsCallBack(ByVal hwnd As Long, ByVal lParam As Long) As Long
Dim lReturn     As Long
Dim sWindowText As String

    If IsWindowVisible(hwnd) Then
        If GetParent(hwnd) = 0 Then
                sWindowText = Space$(256)
                lReturn = GetWindowText(hwnd, sWindowText, Len(sWindowText))
                If lReturn Then
                    sWindowText = Left$(sWindowText, lReturn)
                    If sWindowText <> "Program Manager" Then
                        'If (GetWindowLong(hwnd, GWL_EXSTYLE) And WS_EX_APPWINDOW) <> WS_EX_APPWINDOW Then
                            Arr(UBound(Arr)) = hwnd
                            ReDim Preserve Arr(UBound(Arr) + 1)
                        'End If
                    End If
            End If
        End If
    End If
fEnumWindowsCallBack = True
End Function

Public Function EnumAllWindows() As Variant
    ReDim Arr(0)
    Call EnumWindows(AddressOf fEnumAllWindowsCallBack, GetDesktopWindow)
    EnumAllWindows = Arr
End Function

Private Function fEnumAllWindowsCallBack(ByVal hwnd As Long, ByVal lParam As Long) As Long
        If GetParent(hwnd) = 0 Then
            Arr(UBound(Arr)) = hwnd
            ReDim Preserve Arr(UBound(Arr) + 1)
        End If
fEnumAllWindowsCallBack = True
End Function

