Attribute VB_Name = "mActiveWindow"
'---------------------------------------------------------------------------------------
' Module    :   mActiveWindow
' DateTime  :   06/11/2007 21:10
' Author    :   Cobein
' Mail      :   cobein27@hotmail.com
' Purpose   :
' Requirements:
' Distribution: You can freely use this code in your own
'               applications, but you may not reproduce
'               or publish this code on any web site,
'               online service, or distribute as source
'               on any media without express permission.
'---------------------------------------------------------------------------------------
Option Explicit

Private Const GWL_WNDPROC               As Long = -4

Private Const RSH_DEREGISTER            As Long = 0
Private Const RSH_REGISTER              As Long = 1
Private Const RSH_REGISTER_TASKMAN      As Long = 3
Private Const HSHELL_WINDOWACTIVATED    As Long = 4

Private Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
Private Declare Function RegisterShellHook Lib "Shell32" Alias "#181" (ByVal hwnd As Long, ByVal nAction As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private m_lhWnd As Long
Private m_bHookSet As Boolean
Private m_lOldProc As Long
Private m_lMsg As Long
Private m_cInterface As IActiveWindow

Public Function RemoveHook() As Boolean
    If m_bHookSet Then
        Call RegisterShellHook(m_lhWnd, RSH_DEREGISTER)
        Call SetWindowLong(m_lhWnd, GWL_WNDPROC, m_lOldProc)
        m_bHookSet = False
    End If
End Function

Public Function SetHook(ByVal hwnd As Long, ByVal Interface As IActiveWindow) As Boolean
    Set m_cInterface = Interface
    m_lMsg = RegisterWindowMessage(ByVal "SHELLHOOK")
    Call RegisterShellHook(hwnd, RSH_REGISTER_TASKMAN)
    m_lOldProc = GetWindowLong(hwnd, GWL_WNDPROC)
    Call SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WndProc)
    m_bHookSet = True
    SetHook = m_bHookSet
End Function

Private Function WndProc(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If wMsg = m_lMsg Then
        If wParam = HSHELL_WINDOWACTIVATED Then
            Call m_cInterface.ActiveWindow(lParam)
        End If
    Else
        WndProc = CallWindowProc(m_lOldProc, hwnd, wMsg, wParam, lParam)
    End If
End Function
